/*
 * File: 	date.js
 * Author:	Steven Calello
 * Date:	March 13, 2003
 *
 * Description: This is some simple javascript functions to help you format dates.
 * 		To use this code, copy the following line and paste it into the head tag:
 *			<script language="javascript" type="text/javascript" src="date.js"></script> 
 *		Here is sample/test code that you can paste into the body of you web page:
 *			<SCRIPT language="JavaScript">
 *			<!--
 *			document.write(monthName+"<br>");
 *			document.write(abbreviatedMonth+"<br>");
 *			document.write(dayName+"<br>");
 *			document.write(abbreviatedDay+"<br>");
 *			document.write(leadingZerosMDY()+ "<br>");
 *			document.write(leadingZerosYMD());
 *			//-->
 *			</script>
 * 
 */
//Using the next variables you can build any future / past date
var oneMinute = 60 * 1000;  // milliseconds in a minute
var oneHour = oneMinute * 60;
var oneDay = oneHour * 24;
var oneWeek = oneDay * 7;

var today 	= new Date();
var month	= today.getMonth();
var day 	= today.getDate();
var year 	= today.getYear();
var hour 	= today.getHours();
var minute 	= today.getMinutes();

var yesterdayInMS = today.getTime() - oneDay; // yesterday
var yesterdaysDate = new Date(yesterdayInMS);
var yesterdaysDay = yesterdaysDate.getDate();
var yesterdaysMonth = yesterdaysDate.getMonth();

var tomorrowInMS = today.getTime() + oneDay; // tomorrow
var tomorrowsDate = new Date(tomorrowInMS);
var tomorrowsDay = tomorrowsDate.getDate();
var tomorrowsMonth = tomorrowsDate.getMonth();

var months 			= new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
var monthl 			= new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

var abbrMonthPast   = months[yesterdaysMonth];
var abbrMonthFuture = months[tomorrowsMonth];
var abbreviatedMonth = months[month];

var monthName		= monthl[month];

var days			= new Array("Sun", "Mon", "Tue", "Wed", "Thur", "Fri", "Sat");
var dayl			= new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
var abbreviatedDay	= days[today.getDay()];

var dayName			= dayl[today.getDay()];
var dayNameTomorrow = dayl[tomorrowsDate.getDay()];

var shortDateFormat = "dd/mm/yy";
var dateDelim = "/";

//Offset a date 
//Negative OffsetDays creates a new date in the past
//Positive OffsetDays creates a new date in the past
function OffsetFullDate(OffsetDays, sFullDate){ //use yes for a day,month,year or no for day,month

	var offsetInMS = today.getTime() + (oneDay * OffsetDays); 
	var offsetDate = new Date(offsetInMS);
	var offsetDay = offsetDate.getDate();
	var offsetMonth = offsetDate.getMonth();
	var offsetYear = offsetDate.getYear();
	
	if (sFullDate == "yes"){
		document.write(newFormatDay(offsetDay) + "-" + months[offsetMonth] + "-" + offsetYear)
	}
	else
	{
		document.write(newFormatDay(offsetDay) + "-" + months[offsetMonth])
	}//End if Statement	
}//End Function

// month/day/year
// 01/01/2000
function leadingZerosMDY()
{
  
  this.formatMonth();
  this.formatDay();
        
  var temp = month + "-" + day + "-" + year;
  return temp;
}

// year/month/day
// 2000/01/22
function leadingZerosYMD()
{
  
  this.formatMonth();
  this.formatDay();      
  var temp = year + "-" + month + "-" + day;
  return temp;
}

function InsertLongDate(){
	var longDate = new String;
	var monthNames = new Array('January', 'February','March','April','May','June','July','August','September','October','November','December');
	longDate = monthNames[month]+ ' ' + day + ', ' + year ;
	document.write(longDate);
}
function InsertShortDate(){

	var shortDate = new String;
	var formatArray = shortDateFormat.split(dateDelim)

	for (i = 0; i< formatArray.length; i++) {
		if (formatArray[i] == "d") {shortDate += day;}
		else if (formatArray[i] == "dd") {shortDate += formatDay();}
		else if (formatArray[i] == "mm") {shortDate += formatMonth();}
		else if (formatArray[i] == "m") {shortDate += month;}			
		else if (formatArray[i] == "yy") {shortDate += formatYear();}
		else if (formatArray[i] == "yyyy") {shortDate += year;}
		if( i < formatArray.length -1) {shortDate+="/";}
	}

	document.write(shortDate);
}

/********************/
/*  Helper Methods  */
/********************/

function formatYear() 
{
	var temp = new String(year);
	temp = temp.slice(2);
	return temp;
}

function formatMonth()
{
	if(month <10 )
    {
	   var temp = new String("0" + month);
          return temp;
	}
        return month;
}

function formatDay()
{
  	if(day <10 )
	{
	   var temp = new String("0" + day);
          return temp; 
	}
        return day;
}

function newFormatDay(newDay)
{

  	if(newDay <10 )
	{
	   var temp = new String("0" + newDay);
          return temp; 
	}
        return newDay;
}

//Tasks Dates
function TaskDates(monthAdjust){
	var newMonth = month + monthAdjust
	
	document.write(months[newMonth] + "-" + year)
}

function dateAdd( start, interval, number ) {

	var startMsg = "Sorry the start parameter of the dateAdd function\n"
		startMsg += "must be a valid date format.\n\n"
		startMsg += "Please try again." ;
		
	var	intervalMsg = "Sorry the dateAdd function only accepts\n"
		intervalMsg += "d, h, m OR s intervals.\n\n"
		intervalMsg += "Please try again." ;

	var	numberMsg = "Sorry the number parameter of the dateAdd function\n"
		numberMsg += "must be numeric.\n\n"
		numberMsg += "Please try again." ;
		
	// get the milliseconds for this Date object.
	var buffer = Date.parse( start ) ;
	
	// check that the start parameter is a valid Date.
	if ( isNaN (buffer) ) {
		alert( startMsg ) ;
		return null ;
	}
	
	// check that an interval parameter was not numeric.
	if ( interval.charAt == 'undefined' ) {
		// the user specified an incorrect interval, handle the error.
		alert( intervalMsg ) ;
		return null ;
	}

	// check that the number parameter is numeric.
	if ( isNaN ( number ) )	{
		alert( numberMsg ) ;
		return null ;
	}

	// so far, so good...
	//
	// what kind of add to do?
	switch (interval.charAt(0))
	{
		case 'd': case 'D': 
			number *= 24 ; // days to hours
			// fall through!
		case 'h': case 'H':
			number *= 60 ; // hours to minutes
			// fall through!
		case 'm': case 'M':
			number *= 60 ; // minutes to seconds
			// fall through!
		case 's': case 'S':
			number *= 1000 ; // seconds to milliseconds
			break ;
		default:
			
			// If we get to here then the interval parameter
			// didn't meet the d,h,m,s criteria.  Handle
			// the error.		
			alert(intervalMsg) ;
			return null ;
	}
	return new Date( buffer + number ) ;
}

// Add a new method for the Date class.
function dateAddMethod( interval, number ) {
	return dateAdd( this, interval, number ); 
} 

// Prototype it.
Date.prototype.dateAdd = dateAddMethod; 

